//+-----------------------------------------------------------------------------------+
//|                                                       TMA+CG.mq4                  |
//|                                                           mladen                  |
//| arrowse coded acording to idea presented by rajiv                                 |
//|                                                                                   |
//+-----------------------------------------------------------------------------------+
//|  TMA_CG_jack1.mq4                                                                 |
//+-----------------------------------------------------------------------------------+
//|  Modified by Jack1. Jack1Fx on twitter                                            |
//|                                           26 Jan 2014.    Proundy Australian Day  |
//|  Version 1.02 on 21 Jan 2014.                                                     |
//+-----------------------------------------------------------------------------------+
//#property copyright "rajivxxx"
//#property link      "rajivxxx@gmail.com"
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1  Yellow     //middle line
#property indicator_color2  Red        //upper band
#property indicator_color3  DodgerBlue //LimeGreen  //lower band
#property indicator_color4  DodgerBlue //up arrow
#property indicator_color5  Red        //down arrow
//#property indicator_width4  1
//#property indicator_width5  1


#property indicator_style1  STYLE_DOT  //middle line

//----
//extern string TimeFrame       = "current time frame";
extern int    HalfLength      = 56;
extern int    Price           = PRICE_WEIGHTED;
extern double BandsDeviations = 2.5;
//extern 
bool   Extrapolate     = true;

extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsOnHighLow = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;

//----
double tmBuffer[];
double upBuffer[];
double dnBuffer[];
double wuBuffer[];
double wdBuffer[];
double upArrow[];
double dnArrow[];
double slope[];

//----
string IndicatorFileName;
//int    timeFrame;
double FullLength;
int    OldBars=0;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   //timeFrame  = stringToTimeFrame(TimeFrame);
   HalfLength = MathMax(HalfLength,5);             //error protect
   FullLength = 2.0*HalfLength+1.0;
   
   IndicatorBuffers(8);
         SetIndexBuffer(0,tmBuffer);  SetIndexDrawBegin(0,HalfLength);
         SetIndexBuffer(1,upBuffer);  SetIndexDrawBegin(1,HalfLength);
         SetIndexBuffer(2,dnBuffer);  SetIndexDrawBegin(2,HalfLength);
         
         SetIndexBuffer(3,upArrow);   SetIndexStyle(3,DRAW_LINE); 
         SetIndexBuffer(4,dnArrow);   SetIndexStyle(4,DRAW_LINE); 
         
         SetIndexBuffer(5,wuBuffer);
         SetIndexBuffer(6,wdBuffer);
         
         SetIndexBuffer(7,slope);
         
   
   IndicatorFileName = WindowExpertName();
   
   OldBars=Bars-2;

   return(0);
}
//----------
int deinit() 
{ 
   RemoveObjects("AboveTopBand_SellBar_jack1_");
   RemoveObjects("BelowBotBand_BuyBar_jack1_");

   return(0);
}
//-------------------------------------------------------------------+
void RemoveObjects(string prefix)
//-------------------------------------------------------------------+
{   
   int i;
   string objname;

   for (i = ObjectsTotal(); i >= 0; i--) 
   {
      objname = ObjectName(i);
      if (StringFind(objname, prefix, 0) > -1) ObjectDelete(objname);
   }
} 
/* RemoveObjects*/

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
   //check if a new bar, then, do a run
   if(OldBars==Bars) return(0);
   OldBars=Bars;//a new bar, run further down, reset this flag
   
   int counted_bars=IndicatorCounted();
   int i,j,k,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit=MathMin(Bars-1,Bars-counted_bars+HalfLength);
   
   //----
 	for(i = limit; i >= 0; i--)
   {
      
      if (Extrapolate || (!Extrapolate && i>HalfLength))
      {  
         //calculate new tma
         double sum  = (HalfLength+1)*iMA(NULL,0,1,0,MODE_SMA,Price,i);
         double sumw = (HalfLength+1);
         for(j=1, k=HalfLength; j<=HalfLength; j++, k--)
         {
            sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i+j);
            sumw += k;

            if (j<=i)
            {
               sum  += k*iMA(NULL,0,1,0,MODE_SMA,Price,i-j);
               sumw += k;
            }
         }
         tmBuffer[i] = sum/sumw;
      
         //----
         double diff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-tmBuffer[i];
         if(diff>=0)
         {
            wuBuffer[i] = (wuBuffer[i+1]*(FullLength-1)+MathPow(diff,2))/FullLength;
            wdBuffer[i] =  wdBuffer[i+1]*(FullLength-1)/FullLength;
         }
         else
         {
            wdBuffer[i] = (wdBuffer[i+1]*(FullLength-1)+MathPow(diff,2))/FullLength;
            wuBuffer[i] =  wuBuffer[i+1]*(FullLength-1)/FullLength;
         }
         //----   
         upBuffer[i] = tmBuffer[i] + BandsDeviations*MathSqrt(wuBuffer[i]);
         dnBuffer[i] = tmBuffer[i] - BandsDeviations*MathSqrt(wdBuffer[i]);
      }
      else
      {  tmBuffer[i] = tmBuffer[i+1]; 
         upBuffer[i] = upBuffer[i+1];
         dnBuffer[i] = dnBuffer[i+1]; 
      }     
      //got tmBuffer[i],upBuffer[i],dnBuffer[i]


      //draw color mid line
      upArrow[i] = EMPTY_VALUE;
      dnArrow[i] = EMPTY_VALUE;
      slope[i]   = slope[i+1];
      if (tmBuffer[i] > tmBuffer[i+1]) slope[i] =  1;
      if (tmBuffer[i] < tmBuffer[i+1]) slope[i] = -1;
      if (slope[i]>0) PlotPoint(i,slope[i],upArrow,dnArrow,tmBuffer);
      if (slope[i]<0) PlotPoint(i,slope[i],upArrow,dnArrow,tmBuffer);
      
   
  
      //display signal arrow 
      RefreshRates(); 
   
      if(   (High[i+1]  >upBuffer[i+1] ) 
         && (Close[i+1] >Open[i+1]     ) 
         && (Close[i]   <Open[i]       ) 
        )            
      {  //draw a dot on top of the bar
         string Arrow_name_jack1 = "AboveTopBand_SellBar_jack1_" + TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);  //TimeCurrent()
         ObjectCreate(Arrow_name_jack1, OBJ_ARROW, 0, Time[i], High[i]+iATR(NULL,0,20,i)/5);   //5*pips);  //OBJ_ARROW=22,window=0,
            ObjectSet(Arrow_name_jack1, OBJPROP_ARROWCODE, 222          );  //159
            ObjectSet(Arrow_name_jack1, OBJPROP_COLOR,     OrangeRed    );  //Magenta
            ObjectSet(Arrow_name_jack1, OBJPROP_STYLE,     STYLE_SOLID  );
            ObjectSet(Arrow_name_jack1, OBJPROP_WIDTH,     0            ); 
      }
      else
      if (   (Low[i+1]   <dnBuffer[i+1] ) 
          && (Close[i+1] <Open[i+1]     ) 
          && (Close[i]   >Open[i]       ) 
         )            
      {  //draw a dot on top of the bar
         Arrow_name_jack1 = "BelowBotBand_BuyBar_jack1_" + TimeToStr(Time[i],TIME_DATE|TIME_SECONDS);//TimeCurrent()
         ObjectCreate(Arrow_name_jack1, OBJ_ARROW, 0, Time[i], Low[i]-iATR(NULL,0,20,i)/2);//5*pips);  //OBJ_ARROW=22,window=0,
            ObjectSet(Arrow_name_jack1, OBJPROP_ARROWCODE, 221          );//159
            ObjectSet(Arrow_name_jack1, OBJPROP_COLOR,     DodgerBlue   );//Magenta
            ObjectSet(Arrow_name_jack1, OBJPROP_STYLE,     STYLE_SOLID  );
            ObjectSet(Arrow_name_jack1, OBJPROP_WIDTH,     0            ); 
      }
   }//end for(i = limit; i >= 0; i--)

   //----------------------------------------------
   if (alertsOn)
   {
      if (alertsOnCurrent)
            int forBar = 0;
      else      forBar = 1;
      if (alertsOnHighLow)       
      {
         if (High[forBar] > upBuffer[forBar] && High[forBar+1] < upBuffer[forBar+1]) doAlert("high penetrated upper band");
         if (Low[forBar]  < dnBuffer[forBar] && Low[forBar+1]  > dnBuffer[forBar+1]) doAlert("low penetrated lower band");
      }
      else
      {
         if (Close[forBar] > upBuffer[forBar] && Close[forBar+1] < upBuffer[forBar+1]) doAlert("close penetrated upper band");
         if (Close[forBar] < dnBuffer[forBar] && Close[forBar+1] > dnBuffer[forBar+1]) doAlert("close penetrated lower band");
      }
   } 

   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void doAlert(string doWhat)
{
   static string   previousAlert="";
   static datetime previousTime;
   string message;

   //----
   if (previousAlert!=doWhat || previousTime!=Time[0]) 
   {
      previousAlert = doWhat;
      previousTime  = Time[0];

      message= StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," THA : ",doWhat);
         if (alertsMessage) Alert(message);
         if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"TMA "),message);
         if (alertsSound)   PlaySound("alert2.wav");
    }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
/*
int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int char = StringGetChar(tfs,l);
          if((char > 96 && char < 123) || (char > 223 && char < 256))
               tfs = StringSetChar(tfs, 1, char - 32);
          else 
              if(char > -33 && char < 0)
                  tfs = StringSetChar(tfs, 1, char + 224);
   }
   int tf=0;
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf==0 || tf<Period())      tf=Period();
   return(tf);
}
*/

//---------------------------------------------------------------------------------------------------------
//---------------------------------------------------------------------------------------------------------
/*void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
   if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
        first[i+1] = EMPTY_VALUE;
}
*/
//---------------------------------------------------------------------------------------------------------
void PlotPoint(int i,double move, double& up[],double& dn[],double& from[] )
{
   if(move >0 && up[i+1] != EMPTY_VALUE)
   {
      up[i] = from[i];
      dn[i] = EMPTY_VALUE;
   
   }
   else 
   if(move <0 && dn[i+1] != EMPTY_VALUE)
   {
      dn[i] = from[i];
      up[i] = EMPTY_VALUE;
   }
   else
   if(move >0 && up[i+1] == EMPTY_VALUE)
   {
      up[i] = from[i]; up[i+1] = dn[i+1];
      dn[i] = EMPTY_VALUE;
   }
   else 
   if(move <0 && dn[i+1] == EMPTY_VALUE)
   {
      dn[i] = from[i]; dn[i+1] = up[1+1]; 
      up[i] = EMPTY_VALUE;
   }
}
//+------------------------------------------------------------------+
//|  end                                                             |
//+------------------------------------------------------------------+ 